#version 120

#define AWATER 230.0f // [200.0f 205.0f 210.0f 215.0f 220.0f 225.0f 230.0f]
#define RWATER 0.0f // [0.0f 0.025f 0.05f 0.075f 0.1f 0.125f 0.15f 0.175f 0.2f 0.225f 0.25f 0.275f 0.3f 0.325f 0.35f 0.375f 0.4f 0.425f 0.45f 0.475f 0.5f]
#define GWATER 0.075f // [0.0f 0.01f 0.025f 0.05f 0.075f 0.1f 0.125f 0.15f 0.175f 0.2f 0.225f 0.25f 0.275f 0.3f 0.325f 0.35f 0.375f 0.4f 0.425f 0.45f 0.475f 0.5f]
#define BWATER 0.15f // [0.0f 0.025f 0.05f 0.075f 0.1f 0.125f 0.15f 0.175f 0.2f 0.225f 0.25f 0.275f 0.3f 0.325f 0.35f 0.375f 0.4f 0.425f 0.45f 0.475f 0.5f]

//#define CWATER //Disable custom water, if you want


uniform sampler2D lightmap;
uniform sampler2D texture;

varying float iswater;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;

void main() {
	vec4 color = texture2D(texture, texcoord) * glcolor;
	color *= texture2D(lightmap, lmcoord);
	vec4 vcolor = color;

	#ifdef CWATER
		if (iswater > 0.9) {

			color = vec4(RWATER, GWATER, BWATER, AWATER / 255.0f) * texture2D(lightmap, lmcoord);


		/*
		if (iswater > 0.9) {
			gl_FragData[0] = vec4(color, tex.a);
		}
	*/

			gl_FragData[0] = color;
		} else if (iswater < 0.9) {
			color = vcolor;
			gl_FragData[0] = color;
		}
	#endif


	#ifndef CWATER
		if (iswater > 0.9) {
			color = vcolor;
				gl_FragData[0] = color;
				} else if (iswater < 0.9) {
					color = vcolor;
					gl_FragData[0] = color;
				}
#endif

/* DRAWBUFFERS:0 */
}
